using System;
using System.Collections;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Threading;

namespace Decal.Interop.Filters;

internal sealed class IEchoSink2_EventProvider : IEchoSink2_Event, IDisposable
{
	private IConnectionPointContainer m_ConnectionPointContainer;

	private ArrayList m_aEventSinkHelpers;

	private IConnectionPoint m_ConnectionPoint;

	private void Init()
	{
		IConnectionPoint ppCP = null;
		Guid riid = new Guid(new byte[16]
		{
			133, 204, 155, 108, 208, 186, 6, 71, 156, 197,
			212, 145, 228, 63, 129, 196
		});
		m_ConnectionPointContainer.FindConnectionPoint(ref riid, out ppCP);
		m_ConnectionPoint = ppCP;
		m_aEventSinkHelpers = new ArrayList();
	}

	event IEchoSink2_EchoServerEventHandler IEchoSink2_Event.EchoServer
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IEchoSink2_SinkHelper echoSink2_SinkHelper = new IEchoSink2_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(echoSink2_SinkHelper, out pdwCookie);
				echoSink2_SinkHelper.m_dwCookie = pdwCookie;
				echoSink2_SinkHelper.m_EchoServerDelegate = value;
				m_aEventSinkHelpers.Add(echoSink2_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IEchoSink2_SinkHelper echoSink2_SinkHelper = (IEchoSink2_SinkHelper)m_aEventSinkHelpers[num];
					if (echoSink2_SinkHelper.m_EchoServerDelegate != null && ((echoSink2_SinkHelper.m_EchoServerDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(echoSink2_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	event IEchoSink2_EchoClientEventHandler IEchoSink2_Event.EchoClient
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IEchoSink2_SinkHelper echoSink2_SinkHelper = new IEchoSink2_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(echoSink2_SinkHelper, out pdwCookie);
				echoSink2_SinkHelper.m_dwCookie = pdwCookie;
				echoSink2_SinkHelper.m_EchoClientDelegate = value;
				m_aEventSinkHelpers.Add(echoSink2_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IEchoSink2_SinkHelper echoSink2_SinkHelper = (IEchoSink2_SinkHelper)m_aEventSinkHelpers[num];
					if (echoSink2_SinkHelper.m_EchoClientDelegate != null && ((echoSink2_SinkHelper.m_EchoClientDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(echoSink2_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	public IEchoSink2_EventProvider(object P_0)
	{
		//Error decoding local variables: Signature type sequence must have at least one element.
		m_ConnectionPointContainer = (IConnectionPointContainer)P_0;
	}

	public void Finalize()
	{
		bool lockTaken = default(bool);
		try
		{
			Monitor.Enter(this, ref lockTaken);
			if (m_ConnectionPoint == null)
			{
				return;
			}
			int count = m_aEventSinkHelpers.Count;
			int num = 0;
			if (0 < count)
			{
				do
				{
					IEchoSink2_SinkHelper echoSink2_SinkHelper = (IEchoSink2_SinkHelper)m_aEventSinkHelpers[num];
					m_ConnectionPoint.Unadvise(echoSink2_SinkHelper.m_dwCookie);
					num++;
				}
				while (num < count);
			}
			Marshal.ReleaseComObject(m_ConnectionPoint);
		}
		catch (Exception)
		{
		}
		finally
		{
			if (lockTaken)
			{
				Monitor.Exit(this);
			}
		}
	}

	public void Dispose()
	{
		//Error decoding local variables: Signature type sequence must have at least one element.
		Finalize();
		GC.SuppressFinalize(this);
	}
}
